#ifndef INCLUDED_luxe_utils_json_JSONTokenizer
#define INCLUDED_luxe_utils_json_JSONTokenizer

#ifndef HXCPP_H
#include <hxcpp.h>
#endif

HX_DECLARE_CLASS3(luxe,utils,json,JSONToken)
HX_DECLARE_CLASS3(luxe,utils,json,JSONTokenizer)
namespace luxe{
namespace utils{
namespace json{


class HXCPP_CLASS_ATTRIBUTES  JSONTokenizer_obj : public hx::Object{
	public:
		typedef hx::Object super;
		typedef JSONTokenizer_obj OBJ_;
		JSONTokenizer_obj();
		Void __construct(::String s,bool strict);

	public:
		inline void *operator new( size_t inSize, bool inContainer=true)
			{ return hx::Object::operator new(inSize,inContainer); }
		static hx::ObjectPtr< JSONTokenizer_obj > __new(::String s,bool strict);
		static Dynamic __CreateEmpty();
		static Dynamic __Create(hx::DynamicArray inArgs);
		//~JSONTokenizer_obj();

		HX_DO_RTTI;
		static void __boot();
		static void __register();
		void __Mark(HX_MARK_PARAMS);
		void __Visit(HX_VISIT_PARAMS);
		::String __ToString() const { return HX_CSTRING("JSONTokenizer"); }

		Dynamic obj;
		::String jsonString;
		int loc;
		::String ch;
		bool strict;
		virtual ::luxe::utils::json::JSONToken getNextToken( );
		Dynamic getNextToken_dyn();

		virtual ::luxe::utils::json::JSONToken readString( );
		Dynamic readString_dyn();

		virtual int hexValToInt( ::String hexVal);
		Dynamic hexValToInt_dyn();

		virtual ::luxe::utils::json::JSONToken readNumber( );
		Dynamic readNumber_dyn();

		virtual ::String nextChar( );
		Dynamic nextChar_dyn();

		virtual Void skipIgnored( );
		Dynamic skipIgnored_dyn();

		virtual Void skipComments( );
		Dynamic skipComments_dyn();

		virtual Void skipWhite( );
		Dynamic skipWhite_dyn();

		virtual bool isWhiteSpace( ::String ch);
		Dynamic isWhiteSpace_dyn();

		virtual bool isDigit( ::String ch);
		Dynamic isDigit_dyn();

		virtual bool isHexDigit( ::String ch);
		Dynamic isHexDigit_dyn();

		virtual Void parseError( ::String message);
		Dynamic parseError_dyn();

};

} // end namespace luxe
} // end namespace utils
} // end namespace json

#endif /* INCLUDED_luxe_utils_json_JSONTokenizer */ 
